#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>

void sqlinit(char *);
void db_error();
void show_usage();
char *sse(char *);
char *ssb(char *);
void showproc(char *);

EXEC SQL INCLUDE sqlca;

int main(int argc,char *argv[]){

  char buf[1000],buf2[2],buf3[2],*buf4,buf5[255];
  FILE *f;

  if(argv[1]==NULL)
     show_usage();

  sqlinit(argv[1]);
  showproc(argv[2]);


}

void sqlinit(char *cstring)
{

EXEC SQL WHENEVER SQLERROR DO db_error();
EXEC SQL CONNECT:cstring;

}


void db_error ()
{
  char message_buffer[512];
  size_t buffer_size;
  size_t message_length;

  buffer_size = sizeof (message_buffer);
  sqlglm (message_buffer, &buffer_size, &message_length);
  printf("Database Error\r\n");
  printf ("\n%.*s\n", message_length, message_buffer);
  exit(0);
}  


void show_usage()
{
printf("\r\nCatProc 1.0 by Matthew Chappee matthew@mattshouse.com\r\n");
printf("Usage:\r\n");
printf("catproc username/password@tnsalias procedure\r\n\r\n");
printf("Example: catproc matthew/cim@oneworld MAINCIMPROC\r\n");
exit(0);
}

void showproc(char *buf)
{
char buf2[1000];
int b=0,c=0,d=0;


EXEC SQL DECLARE msg2 CURSOR FOR
    SELECT text
    FROM user_source
    WHERE name = :buf
    ORDER BY line;

EXEC SQL OPEN msg2;

EXEC SQL
   FETCH msg2
   INTO :buf2;

sse(buf2);

while(buf2[b]){
 if(buf2[b]==' ')
    c++;   
 
 if(buf2[b]!=' ' && c)
    d++;
   
 if(buf2[b]==' ' && d)
    break; 
 
 b++;
}

EXEC SQL WHENEVER NOT FOUND DO break;

for (;;)
    {

     EXEC SQL        
      FETCH msg2
      INTO :buf2;

     printf(sse(buf2));

    }
  EXEC SQL CLOSE msg2;
  EXEC SQL WHENEVER NOT FOUND CONTINUE;

}

